VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_dollars_to_words3"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkUseUsGroupNames 
      Caption         =   "Use US Group Names"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   480
      Value           =   1  'Checked
      Width           =   3015
   End
   Begin VB.TextBox txtResult 
      BackColor       =   &H00C0C0C0&
      Height          =   1815
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   1320
      Width           =   4455
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   1853
      TabIndex        =   2
      Top             =   840
      Width           =   975
   End
   Begin VB.TextBox txtNumber 
      Height          =   285
      Left            =   840
      TabIndex        =   1
      Text            =   "$123,456,789,012,345,678,901,234,567,890.12"
      Top             =   120
      Width           =   3735
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Number:"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   600
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Convert a number between 0 and 999 into words.
Private Function GroupToWords(ByVal num As Integer) As String
Static done_before As Boolean
Static one_to_nineteen() As String
Static multiples_of_ten() As String

Dim digit As Integer
Dim result As String

    If Not done_before Then
        done_before = True
        one_to_nineteen = Split("zero,one,two,three,four,five,six,seven,eight,nine,ten,eleven,twelve,thirteen,fourteen,fifteen,sixteen,seventeen,eightteen,nineteen", ",")
        multiples_of_ten = Split("twenty,thirty,forty,fifty,sixty,seventy,eighty,ninety", ",")
    End If

    ' If the number is 0, return an empty string.
    GroupToWords = ""
    If num = 0 Then Exit Function

    ' Handle the hundreds digit.
    result = ""
    If num > 99 Then
        digit = num \ 100
        num = num Mod 100
        result = one_to_nineteen(digit) & " hundred"
    End If

    ' If num = 0, we have hundreds only.
    If num = 0 Then
        GroupToWords = Trim$(result)
        Exit Function
    End If

    ' See if the rest is less than 20.
    If num < 20 Then
        ' Look up the correct name.
        result = result & " " & one_to_nineteen(num)
    Else
        ' Handle the tens digit.
        digit = num \ 10
        num = num Mod 10
        result = result & " " & multiples_of_ten(digit - 2)

        ' Handle the final digit.
        If num > 0 Then
            result = result & " " & one_to_nineteen(num)
        End If
    End If

    GroupToWords = Trim$(result)
End Function

' Return a word representation of the whole number value.
Private Function NumberToString(ByVal num_str As String, Optional ByVal use_us_group_names As Boolean = True) As String
Const CURRENCY_CHAR As String = "$"
Const SEPARATOR As String = ","
Const DECIMAL_POINT As String = "."

Dim groups() As String
Dim pos As Integer
Dim num_groups As Integer
Dim result As String
Dim group_num As Integer
Dim group_str As String
Dim group_value As Integer

    ' Get the appropiate group names.
    If use_us_group_names Then
        groups = Split(",thousand,million,billion,trillion,quadrillion,quintillion,sextillion,septillion,octillion,nonillion,decillion,undecillion,duodecillion,tredecillion,quattuordecillion,quindecillion,sexdecillion,septendecillion,octodecillion,novemdecillion,vigintillion", ",")
    Else
        groups = Split(",thousand,million,milliard,billion,1000 billion,trillion,1000 trillion,quadrillion,1000 quadrillion,quintillion,1000 quintillion,sextillion,1000 sextillion,septillion,1000 septillion,octillion,1000 octillion,nonillion,1000 nonillion,decillion,1000 decillion", ",")
    End If

    ' Clean the string a bit.
    ' Remove "$", ",", leading zeros, and
    ' anything after a decimal point.
    num_str = Replace$(num_str, CURRENCY_CHAR, "")
    num_str = Replace$(num_str, SEPARATOR, "")
    Do While Left$(num_str, 1) = "0"
        num_str = Mid$(num_str, 2)
    Loop
    pos = InStr(num_str, DECIMAL_POINT)
    If pos = 1 Then
        NumberToString = "zero"
        Exit Function
    ElseIf pos > 1 Then
        num_str = Left$(num_str, pos - 1)
    End If

    ' See how many groups there will be.
    num_groups = (Len(num_str) + 2) \ 3

    ' Pad so length is a multiple of 3.
    num_str = Space$(num_groups * 3 - Len(num_str)) & num_str

    ' Process the groups, largest first.
    result = ""
    For group_num = num_groups - 1 To 0 Step -1
        ' Get the next three digits.
        group_str = Mid$(num_str, 1, 3)
        num_str = Mid$(num_str, 4)
        group_value = CInt(group_str)

        ' Convert the group into words.
        If group_value > 0 Then
            If group_num >= UBound(groups) Then
                result = result & GroupToWords(group_value) & _
                    " ?, "
            Else
                result = result & GroupToWords(group_value) & _
                    " " & groups(group_num) & ", "
            End If
        End If
    Next group_num

    ' Remove the trailing ", ".
    If Right$(result, 2) = ", " Then
        result = Left$(result, Len(result) - 2)
    ElseIf Len(result) = 0 Then
        result = "zero"
    End If

    NumberToString = Trim$(result)
End Function

Private Sub cmdGo_Click()
'    txtResult.Text = _
'        DollarsToString( _
'            txtNumber.Text, _
'            " AND ", "/100 dollars", chkUseUsGroupNames.Value = vbChecked)
    txtResult.Text = _
        DollarsToString( _
            txtNumber.Text, _
            , , chkUseUsGroupNames.Value = vbChecked)
End Sub
' Return a word representation of a dollar amount.
Private Function DollarsToString(ByVal num_str As String, Optional ByVal after_dollars As String = " DOLLARS AND ", Optional ByVal after_cents As String = " CENTS", Optional ByVal use_us_group_names As Boolean = True) As String
Const CURRENCY_CHAR As String = "$"
Const SEPARATOR As String = ","
Const DECIMAL_POINT As String = "."

Dim pos As Integer
Dim dollars As String
Dim cents As String
Dim dollars_str As String
Dim cents_str As String

    ' Clean the string a bit.
    ' Remove "$", ",", and leading zeros.
    num_str = Replace$(num_str, CURRENCY_CHAR, "")
    num_str = Replace$(num_str, SEPARATOR, "")
    Do While Left$(num_str, 1) = "0"
        num_str = Mid$(num_str, 2)
    Loop

    ' Get the dollar and cents parts.
    pos = InStr(num_str, DECIMAL_POINT)
    dollars = ""
    cents = ""
    If pos < 1 Then
        dollars = num_str
    ElseIf pos = 1 Then
        cents = Mid$(num_str, pos + 1)
    Else
        dollars = Left$(num_str, pos - 1)
        cents = Mid$(num_str, pos + 1)
    End If

    ' Convert the cents string into 1/100ths of a dollar.
    cents = cents & "0"
    cents = Left$(cents, 2) & "." & Mid$(cents, 3)
    cents = Format$(CInt(cents))

    ' Convert the parts into words.
    dollars_str = NumberToString(dollars, use_us_group_names)
    cents_str = NumberToString(cents, use_us_group_names)

    DollarsToString = _
        dollars_str & after_dollars & _
        cents_str & after_cents
End Function

Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth - txtNumber.Left - 120
    If wid < 120 Then wid = 120
    txtNumber.Width = wid

    wid = ScaleWidth - txtResult.Left - 120
    If wid < 120 Then wid = 120
    hgt = ScaleHeight - txtResult.Top - 120
    If hgt < 120 Then hgt = 120
    txtResult.Move txtResult.Left, txtResult.Top, wid, hgt

    cmdGo.Left = (ScaleWidth - cmdGo.Width) / 2
End Sub


